; 1-Bit-Ssound
; ein kleines Musikprogramm, das Musik ber den eingebauten Piepser abspielt.
; 
; orig. Spectrum, an Z9001 adaptiert V. Pohlers 04.01.2014
; Spectrum-Taktfrequenz ist 3.5 Mhz, daher ist das auf dem Z9001 noch etwas langsamer und tiefer


		cpu	Z80undoc
		RELAXED ON  			; f. Hex-Zahlen

;-----------------------------------------------------------------------------
; Systemadressen, OS-Kommandorahmen
;-----------------------------------------------------------------------------

CTC0		equ	80h			; Kassette und Piepser
BPORT		equ	136			; Port f. Piepser

		org	300h
		jp	start
		db	"AMELIE  ",0
		jp	TON
		db	"TON     ",0
		db	0

;------------------------------------------------------------------------------
; TON
;------------------------------------------------------------------------------

start:		call	tontest

		ld	de, aTitle
		ld	c, 9		; Zeichenkette ausgeben
		call	5
start0:		ld	c, 1		; Konsoleneingabe
		call	5
		and	5Fh 		; Klein->Gro
		cp	'J'
		jr	z, start1
		cp	'N'
		jp	nz, start0
		;Nein
		call	ton		;Ton init.
start1		ld	de, aMenu
		ld	c, 9		; Zeichenkette ausgeben
		call	5
		jp	startx

aTitle:		db	0dh,0ah,"1-BIT-MUSIK nach ZX-Spectrum"
		db	0dh,0ah,"Volker Pohlers 12/2013"
		db	0dh,0ah,0ah
aTon:		db 	"War ein Ton zu hoeren J/N?",0
aMenu:		db	0dh,0ah,0ah,"irrlicht project-l'autre valse d'Amelie",0

;------------------------------------------------------------------------------
; TON
;------------------------------------------------------------------------------


; CTC genau einen Impuls erzeugen
; CTC 1 Flanke erzeugen

; ISR
ictc0:		ld	a,3
		out	(CTC0), a
		EI
		RETI

ton:		ld	de,(200h)
		ld	hl, ictc0
		ld	(200h), hl	; Interrupt-Routine
		ld	a,3
		out	(CTC0), a
		ld	a, 85h
		out	(CTC0), a
		ld	a, 1		; Zeitkonstante, 16 Takte
		out	(CTC0), a
		ld	a,(ix+0)	; 19 Takte Pause
		ld	(200h),de

; Tonausgabe ber PIO testen

tontest:	LD	BC,0A040H
		CALL	BEEP
		LD	BC,00A00H
		CALL	BEEP
		LD	BC,0A040H
		CALL	BEEP
;
		xor 	a
		ret

;Tonausgabe
;  C=Tonhoehe, B=Tondauer
;
BEEP:	PUSH	BC
BEEP1:	PUSH	BC
	LD	A,C
	OR	A
	LD	A,0
	JR	Z, BEEP2		;C=0 --> kein Ton
	LD	A,128			;Beep an
BEEP2:	OUT	(BPORT), A
	POP	BC
	PUSH	BC
BEEP3:	DEC	C
	JR	NZ, BEEP3		;Flanke abwarten
	LD	A,0
	OUT	(BPORT), A		;Beep aus
	POP	BC
	PUSH	BC
BEEP4:	DEC	C
	JR	NZ, BEEP4		;Flanke abwarten
	POP	BC
	DJNZ	BEEP1			;Tondauer
	POP	BC
	RET
;




; *****************************************************************************
; * The Music Box Player Engine
; *
; * Based on code written by Mark Alexander for the utility, The Music Box.
; * Modified by Chris Cowley
; *
; * Produced by Beepola v1.08.01
; ******************************************************************************
 
;zx spectrum
; http://www.zxdesign.info/cassette.shtml
; 
; The 48K ZX Spectrum handles all cassette IO through a single ULA pin, as well as 
; the internal speaker. The significant bits of port 0xFE are (see interfaces for 
; further information). 
; 
; 	  7  6  5       4     3     2  1  0
; Output ... ... ... Speaker Mic Green Red Blue 
; Input  ... Ear ...        Keyboard 
; 
; 
; The Speaker, Ear socket and Mic socket are all connected to the same ULA pin. 
; Setting bit 4 of port 0xFE high produces a larger voltage at the pin than 
; setting bit 3. For this reason bit 4 is used for sound generation as it will 
; produce the louder sound, and hence it has the 'speaker' label, but you could 
; use bit 3.
; On the input side, it is bit 6 of port 0xFE that returns the state of the ULA 
; pin.
; 
; ZX clock frequence 3.5 MHz
 
STARTx:
			in a, (bport)
                          LD   (BORDER_COL), A


                          LD    HL,MUSICDATA         ;  <- Pointer to Music Data. Change
                                                     ;     this to play a different song
                          LD   A,(HL)                         ; Get the loop start pointer
                          LD   (PATTERN_LOOP_BEGIN),A
                          INC  HL
                          LD   A,(HL)                         ; Get the song end pointer
                          LD   (PATTERN_LOOP_END),A
                          INC  HL
                          LD   (PATTERNDATA1),HL
                          LD   (PATTERNDATA2),HL
                          LD   A,254
                          LD   (PATTERN_PTR),A                ; Set the pattern pointer to zero
                          DI
                          CALL  NEXT_PATTERN
NEXTNOTE:
                          CALL  PLAYNOTE
;                          XOR   A
;                          IN    A,(BPORT)
;                          AND   $1F
;                          CP    $1F
                          JR    NEXTNOTE                    ; Play next note if no key pressed

                          EI
                          
                          XOR	A
                          RET                                 ; Return from playing tune

PATTERN_PTR:              DEFB 0
NOTE_PTR:                 DEFB 0


; ********************************************************************************************************
; * NEXT_PATTERN
; *
; * Select the next pattern in sequence (and handle looping if we've reached PATTERN_LOOP_END
; * Execution falls through to PLAYNOTE to play the first note from our next pattern
; ********************************************************************************************************
NEXT_PATTERN:
                          LD   A,(PATTERN_PTR)
                          INC  A
                          INC  A
                          DEFB $FE                           ; CP n
PATTERN_LOOP_END:         DEFB 0
                          JR   NZ,NO_PATTERN_LOOP
                          DEFB $3E                           ; LD A,n
PATTERN_LOOP_BEGIN:       DEFB 0
NO_PATTERN_LOOP:          LD   (PATTERN_PTR),A
			                    DEFB $21                            ; LD HL,nn
PATTERNDATA1:             DEFW $0000
                          LD   E,A                            ; (this is the first byte of the pattern)
                          LD   D,0                            ; and store it at TEMPO
                          ADD  HL,DE
                          LD   E,(HL)
                          INC  HL
                          LD   D,(HL)
                          LD   A,(DE)                         ; Pattern Tempo -> A
	                	      LD   (TEMPO),A                      ; Store it at TEMPO

                          LD   A,1
                          LD   (NOTE_PTR),A

PLAYNOTE: 
			                    DEFB $21                            ; LD HL,nn
PATTERNDATA2:             DEFW $0000
                          LD   A,(PATTERN_PTR)
                          LD   E,A
                          LD   D,0
                          ADD  HL,DE
                          LD   E,(HL)
                          INC  HL
                          LD   D,(HL)                         ; Now DE = Start of Pattern data
                          LD   A,(NOTE_PTR)
                          LD   L,A
                          LD   H,0
                          ADD  HL,DE                          ; Now HL = address of note data
                          LD   D,(HL)
                          LD   E,1

; IF D = $0 then we are at the end of the pattern so increment PATTERN_PTR by 2 and set NOTE_PTR=0
                          LD   A,D
                          AND  A                              ; Optimised CP 0
                          JR   Z,NEXT_PATTERN

                          PUSH DE
                          INC  HL
                          LD   D,(HL)
                          LD   E,1

                          LD   A,(NOTE_PTR)
                          INC  A
                          INC  A
                          LD   (NOTE_PTR),A                   ; Increment the note pointer by 2 (one note per chan)

                          POP  HL                             ; Now CH1 freq is in HL, and CH2 freq is in DE

                          LD   A,H
                          DEC  A
                          JR   NZ,OUTPUT_NOTE

                          LD   A,D                            ; executed only if Channel 2 contains a rest
                          DEC  A                              ; if DE (CH1 note) is also a rest then..
                          JR   Z,PLAY_SILENCE                 ; Play silence

OUTPUT_NOTE:              LD   A,(TEMPO)
                          LD   C,A
                          LD   B,0
                          LD   A,(BORDER_COL)
                          EX   AF,AF'
                          LD   A,(BORDER_COL)                   ; So now BC = TEMPO, A and A' = BORDER_COL
                          LD   IXU,D
                         ; LD   D,$10
                         LD   D,$80	; zu toggelndes Bit
EAE5:                     NOP
                          NOP
EAE7:                     EX   AF,AF'
                          DEC  E
                          OUT  (BPORT),A
                          JR   NZ,EB04

                          LD   E,IXU
                          XOR  D
                          EX   AF,AF'
                          DEC  L
                          JP   NZ,EB0B

EAF5:                     OUT  (BPORT),A
                          LD   L,H
                          XOR  D
                          DJNZ EAE5

                          INC  C
                          JP   NZ,EAE7

                          RET

EB04:
                          JR   Z,EB04
                          EX   AF,AF'
                          DEC  L
                          JP   Z,EAF5
EB0B:
                          OUT  (BPORT),A
                          NOP
                          NOP
                          DJNZ EAE5
                          INC  C
                          JP   NZ,EAE7
                          RET

PLAY_SILENCE:
                          LD   A,(TEMPO)
                          CPL
                          LD   C,A
SILENCE_LOOP2:            PUSH BC
                          PUSH AF
                          LD   B,0
SILENCE_LOOP:             PUSH HL
                          LD   HL,SILENCE_LOOP_BYTE
                          SRA  (HL)
                          SRA  (HL)
                          SRA  (HL)
                          NOP
                          POP  HL
                          DJNZ SILENCE_LOOP
                          DEC  C
                          JP   NZ,SILENCE_LOOP
                          POP  AF
                          POP  BC
                          RET


; *** DATA ***
BORDER_COL:               DEFB	0
TEMPO:                    DEFB 250
SILENCE_LOOP_BYTE	defb 0

MUSICDATA:
                    DEFB 0   ; Loop start point * 2
                    DEFB 24   ; Song Length * 2
PATTERNDATA:        DEFW      PAT0
                    DEFW      PAT1
                    DEFW      PAT0
                    DEFW      PAT1
                    DEFW      PAT2
                    DEFW      PAT3
                    DEFW      PAT7
                    DEFW      PAT8
                    DEFW      PAT4
                    DEFW      PAT5
                    DEFW      PAT4
                    DEFW      PAT5

; *** Pattern data consists of pairs of frequency values CH1,CH2 with a single $0 to
; *** Mark the end of the pattern, and $01 for a rest
PAT0:
         DEFB 250  ; Pattern tempo
             DEFB 151,1
             DEFB 151,1
             DEFB 151,1
             DEFB 151,1
             DEFB 151,1
             DEFB 151,1
             DEFB 151,1
             DEFB 1,1
             DEFB 61,40
             DEFB 51,40
             DEFB 61,40
             DEFB 51,40
             DEFB 1,38
             DEFB 1,38
             DEFB 1,38
             DEFB 1,38
             DEFB 61,34
             DEFB 51,34
             DEFB 61,34
             DEFB 51,34
             DEFB 1,30
             DEFB 1,30
             DEFB 1,30
             DEFB 1,30
             DEFB 151,34
             DEFB 151,34
             DEFB 151,34
             DEFB 151,34
             DEFB 151,34
             DEFB 151,34
             DEFB 151,34
             DEFB 1,34
             DEFB 61,34
             DEFB 51,34
             DEFB 61,34
             DEFB 51,34
             DEFB 1,34
             DEFB 1,34
             DEFB 1,34
             DEFB 1,34
             DEFB 61,34
             DEFB 51,34
             DEFB 61,34
             DEFB 51,34
             DEFB 1,34
             DEFB 1,34
             DEFB 1,34
             DEFB 1,34
             DEFB 151,1
             DEFB 151,1
             DEFB 151,1
             DEFB 151,1
             DEFB 151,1
             DEFB 151,1
             DEFB 151,1
             DEFB 1,1
             DEFB 61,40
             DEFB 51,40
             DEFB 61,40
             DEFB 51,40
             DEFB 1,38
             DEFB 1,38
             DEFB 1,38
             DEFB 1,38
             DEFB 61,34
             DEFB 51,34
             DEFB 61,34
             DEFB 51,34
             DEFB 1,30
             DEFB 1,30
             DEFB 1,30
             DEFB 1,30
             DEFB 151,34
             DEFB 151,34
             DEFB 151,34
             DEFB 151,34
             DEFB 151,34
             DEFB 151,34
             DEFB 151,34
             DEFB 1,34
             DEFB 61,38
             DEFB 51,38
             DEFB 61,38
             DEFB 51,38
             DEFB 1,38
             DEFB 1,38
             DEFB 1,38
             DEFB 1,38
             DEFB 61,38
             DEFB 51,38
             DEFB 61,38
             DEFB 51,38
             DEFB 1,40
             DEFB 1,40
             DEFB 1,40
             DEFB 1,40
         DEFB $0
PAT1:
         DEFB 250  ; Pattern tempo
             DEFB 192,43
             DEFB 192,43
             DEFB 192,43
             DEFB 192,43
             DEFB 192,43
             DEFB 192,43
             DEFB 192,43
             DEFB 1,43
             DEFB 76,43
             DEFB 64,43
             DEFB 76,43
             DEFB 64,43
             DEFB 1,43
             DEFB 1,43
             DEFB 1,43
             DEFB 1,43
             DEFB 76,43
             DEFB 64,43
             DEFB 76,43
             DEFB 64,43
             DEFB 1,43
             DEFB 1,43
             DEFB 1,43
             DEFB 1,43
             DEFB 192,48
             DEFB 192,48
             DEFB 192,48
             DEFB 192,48
             DEFB 192,48
             DEFB 192,48
             DEFB 192,48
             DEFB 1,48
             DEFB 76,48
             DEFB 64,48
             DEFB 76,48
             DEFB 64,48
             DEFB 1,48
             DEFB 1,48
             DEFB 1,48
             DEFB 1,48
             DEFB 76,48
             DEFB 64,48
             DEFB 76,48
             DEFB 64,48
             DEFB 1,48
             DEFB 1,48
             DEFB 1,48
             DEFB 1,48
             DEFB 192,51
             DEFB 192,51
             DEFB 192,51
             DEFB 192,51
             DEFB 192,51
             DEFB 192,51
             DEFB 192,51
             DEFB 1,51
             DEFB 76,51
             DEFB 64,51
             DEFB 76,51
             DEFB 64,51
             DEFB 1,51
             DEFB 1,51
             DEFB 1,51
             DEFB 1,51
             DEFB 76,51
             DEFB 64,51
             DEFB 76,51
             DEFB 64,51
             DEFB 1,51
             DEFB 1,51
             DEFB 1,51
             DEFB 1,51
             DEFB 192,48
             DEFB 192,48
             DEFB 192,48
             DEFB 192,48
             DEFB 192,48
             DEFB 192,48
             DEFB 192,48
             DEFB 1,48
             DEFB 76,48
             DEFB 64,48
             DEFB 76,48
             DEFB 64,48
             DEFB 1,48
             DEFB 1,48
             DEFB 1,48
             DEFB 1,48
             DEFB 76,48
             DEFB 64,48
             DEFB 76,48
             DEFB 64,48
             DEFB 1,48
             DEFB 1,48
             DEFB 1,48
             DEFB 1,48
         DEFB $0
PAT2:
         DEFB 250  ; Pattern tempo
             DEFB 151,40
             DEFB 151,20
             DEFB 151,40
             DEFB 151,20
             DEFB 151,40
             DEFB 151,20
             DEFB 151,40
             DEFB 1,20
             DEFB 61,40
             DEFB 51,20
             DEFB 61,40
             DEFB 51,20
             DEFB 1,40
             DEFB 1,20
             DEFB 1,40
             DEFB 1,20
             DEFB 61,40
             DEFB 51,20
             DEFB 61,40
             DEFB 51,20
             DEFB 1,40
             DEFB 1,20
             DEFB 1,40
             DEFB 1,20
             DEFB 151,38
             DEFB 151,19
             DEFB 151,38
             DEFB 151,19
             DEFB 151,38
             DEFB 151,19
             DEFB 151,38
             DEFB 1,19
             DEFB 61,38
             DEFB 51,19
             DEFB 61,38
             DEFB 51,19
             DEFB 1,38
             DEFB 1,19
             DEFB 1,38
             DEFB 1,19
             DEFB 61,38
             DEFB 51,19
             DEFB 61,38
             DEFB 51,19
             DEFB 1,38
             DEFB 1,19
             DEFB 1,38
             DEFB 1,19
             DEFB 151,34
             DEFB 151,17
             DEFB 151,34
             DEFB 151,17
             DEFB 151,34
             DEFB 151,17
             DEFB 151,34
             DEFB 1,17
             DEFB 61,34
             DEFB 51,17
             DEFB 61,34
             DEFB 51,17
             DEFB 1,34
             DEFB 1,17
             DEFB 1,34
             DEFB 1,17
             DEFB 61,34
             DEFB 51,17
             DEFB 61,34
             DEFB 51,17
             DEFB 1,34
             DEFB 1,17
             DEFB 1,34
             DEFB 1,17
             DEFB 151,30
             DEFB 151,15
             DEFB 151,30
             DEFB 151,15
             DEFB 151,30
             DEFB 151,15
             DEFB 151,30
             DEFB 1,15
             DEFB 61,30
             DEFB 51,15
             DEFB 61,30
             DEFB 51,15
             DEFB 1,30
             DEFB 1,15
             DEFB 1,30
             DEFB 1,15
             DEFB 61,30
             DEFB 51,15
             DEFB 61,30
             DEFB 51,15
             DEFB 1,30
             DEFB 1,15
             DEFB 1,30
             DEFB 1,15
         DEFB $0
PAT3:
         DEFB 250  ; Pattern tempo
             DEFB 192,51
             DEFB 192,25
             DEFB 192,51
             DEFB 192,25
             DEFB 192,51
             DEFB 192,25
             DEFB 192,51
             DEFB 1,25
             DEFB 76,51
             DEFB 64,25
             DEFB 76,51
             DEFB 64,25
             DEFB 1,51
             DEFB 1,25
             DEFB 1,51
             DEFB 1,25
             DEFB 76,51
             DEFB 64,25
             DEFB 76,51
             DEFB 64,25
             DEFB 1,51
             DEFB 1,25
             DEFB 1,51
             DEFB 1,25
             DEFB 192,48
             DEFB 192,24
             DEFB 192,48
             DEFB 192,24
             DEFB 192,48
             DEFB 192,24
             DEFB 192,48
             DEFB 1,24
             DEFB 76,48
             DEFB 64,24
             DEFB 76,48
             DEFB 64,24
             DEFB 1,48
             DEFB 1,24
             DEFB 1,48
             DEFB 1,24
             DEFB 76,48
             DEFB 64,24
             DEFB 76,48
             DEFB 64,24
             DEFB 1,48
             DEFB 1,24
             DEFB 1,48
             DEFB 1,24
             DEFB 192,43
             DEFB 192,21
             DEFB 192,43
             DEFB 192,21
             DEFB 192,43
             DEFB 192,21
             DEFB 192,43
             DEFB 1,21
             DEFB 76,43
             DEFB 64,21
             DEFB 76,43
             DEFB 64,21
             DEFB 1,43
             DEFB 1,21
             DEFB 1,43
             DEFB 1,21
             DEFB 76,43
             DEFB 64,21
             DEFB 76,43
             DEFB 64,21
             DEFB 1,43
             DEFB 1,21
             DEFB 1,43
             DEFB 1,21
             DEFB 192,38
             DEFB 192,19
             DEFB 192,38
             DEFB 192,19
             DEFB 192,38
             DEFB 192,19
             DEFB 192,38
             DEFB 1,19
             DEFB 76,38
             DEFB 64,19
             DEFB 76,38
             DEFB 64,19
             DEFB 1,38
             DEFB 1,19
             DEFB 1,38
             DEFB 1,19
             DEFB 76,38
             DEFB 64,19
             DEFB 76,38
             DEFB 64,19
             DEFB 1,38
             DEFB 1,19
             DEFB 1,38
             DEFB 1,20
         DEFB $0
PAT4:
         DEFB 250  ; Pattern tempo
             DEFB 151,20
             DEFB 151,20
             DEFB 151,20
             DEFB 151,1
             DEFB 151,19
             DEFB 151,1
             DEFB 151,19
             DEFB 1,1
             DEFB 121,20
             DEFB 102,1
             DEFB 121,20
             DEFB 102,1
             DEFB 1,19
             DEFB 1,1
             DEFB 1,19
             DEFB 1,1
             DEFB 121,20
             DEFB 102,1
             DEFB 121,20
             DEFB 102,1
             DEFB 1,19
             DEFB 1,1
             DEFB 1,19
             DEFB 1,1
             DEFB 151,23
             DEFB 151,23
             DEFB 151,23
             DEFB 151,1
             DEFB 151,19
             DEFB 151,1
             DEFB 151,19
             DEFB 1,1
             DEFB 121,23
             DEFB 102,1
             DEFB 121,23
             DEFB 102,1
             DEFB 1,19
             DEFB 1,1
             DEFB 1,19
             DEFB 1,1
             DEFB 121,23
             DEFB 102,1
             DEFB 121,23
             DEFB 102,1
             DEFB 1,19
             DEFB 1,1
             DEFB 1,19
             DEFB 1,1
             DEFB 151,25
             DEFB 151,25
             DEFB 151,25
             DEFB 151,1
             DEFB 151,19
             DEFB 151,1
             DEFB 151,19
             DEFB 1,1
             DEFB 121,25
             DEFB 102,1
             DEFB 121,25
             DEFB 102,1
             DEFB 1,19
             DEFB 1,1
             DEFB 1,19
             DEFB 1,1
             DEFB 121,25
             DEFB 102,1
             DEFB 121,25
             DEFB 102,1
             DEFB 1,19
             DEFB 1,1
             DEFB 1,19
             DEFB 1,1
             DEFB 151,28
             DEFB 151,28
             DEFB 151,28
             DEFB 151,1
             DEFB 151,19
             DEFB 151,1
             DEFB 151,19
             DEFB 1,1
             DEFB 121,28
             DEFB 102,1
             DEFB 121,28
             DEFB 102,1
             DEFB 1,19
             DEFB 1,1
             DEFB 1,19
             DEFB 1,1
             DEFB 121,30
             DEFB 102,1
             DEFB 121,30
             DEFB 102,1
             DEFB 1,19
             DEFB 1,1
             DEFB 1,19
             DEFB 1,1
         DEFB $0
PAT5:
         DEFB 250  ; Pattern tempo
             DEFB 192,21
             DEFB 192,21
             DEFB 192,21
             DEFB 192,1
             DEFB 192,19
             DEFB 192,1
             DEFB 192,19
             DEFB 1,1
             DEFB 151,21
             DEFB 128,1
             DEFB 151,21
             DEFB 128,1
             DEFB 1,19
             DEFB 1,1
             DEFB 1,19
             DEFB 1,1
             DEFB 151,21
             DEFB 128,1
             DEFB 151,21
             DEFB 128,1
             DEFB 1,19
             DEFB 1,1
             DEFB 1,19
             DEFB 1,1
             DEFB 192,24
             DEFB 192,24
             DEFB 192,24
             DEFB 192,1
             DEFB 192,19
             DEFB 192,1
             DEFB 192,19
             DEFB 1,1
             DEFB 151,24
             DEFB 128,1
             DEFB 151,24
             DEFB 128,1
             DEFB 1,19
             DEFB 1,1
             DEFB 1,19
             DEFB 1,1
             DEFB 151,24
             DEFB 128,1
             DEFB 151,24
             DEFB 128,1
             DEFB 1,19
             DEFB 1,1
             DEFB 1,19
             DEFB 1,1
             DEFB 192,25
             DEFB 192,25
             DEFB 192,25
             DEFB 192,1
             DEFB 192,19
             DEFB 192,1
             DEFB 192,19
             DEFB 1,1
             DEFB 151,25
             DEFB 128,1
             DEFB 151,25
             DEFB 128,1
             DEFB 1,19
             DEFB 1,1
             DEFB 1,19
             DEFB 1,1
             DEFB 151,25
             DEFB 128,1
             DEFB 151,25
             DEFB 128,1
             DEFB 1,19
             DEFB 1,1
             DEFB 1,19
             DEFB 1,1
             DEFB 192,24
             DEFB 192,24
             DEFB 192,24
             DEFB 192,1
             DEFB 192,32
             DEFB 192,1
             DEFB 192,32
             DEFB 1,1
             DEFB 151,27
             DEFB 128,1
             DEFB 151,27
             DEFB 128,1
             DEFB 1,25
             DEFB 1,1
             DEFB 1,25
             DEFB 1,1
             DEFB 151,24
             DEFB 128,1
             DEFB 151,24
             DEFB 128,1
             DEFB 1,21
             DEFB 1,1
             DEFB 1,21
             DEFB 1,1
         DEFB $0
PAT7:
         DEFB 250  ; Pattern tempo
             DEFB 151,40
             DEFB 151,20
             DEFB 151,40
             DEFB 151,20
             DEFB 151,40
             DEFB 151,20
             DEFB 151,40
             DEFB 1,20
             DEFB 61,40
             DEFB 51,20
             DEFB 61,40
             DEFB 51,20
             DEFB 1,40
             DEFB 1,20
             DEFB 1,40
             DEFB 1,20
             DEFB 61,40
             DEFB 51,20
             DEFB 61,40
             DEFB 51,20
             DEFB 1,40
             DEFB 1,20
             DEFB 1,40
             DEFB 1,19
             DEFB 151,38
             DEFB 151,19
             DEFB 151,38
             DEFB 151,19
             DEFB 151,38
             DEFB 151,19
             DEFB 151,38
             DEFB 1,19
             DEFB 61,38
             DEFB 51,19
             DEFB 61,38
             DEFB 51,19
             DEFB 1,38
             DEFB 1,19
             DEFB 1,38
             DEFB 1,19
             DEFB 61,38
             DEFB 51,19
             DEFB 61,38
             DEFB 51,19
             DEFB 1,38
             DEFB 1,19
             DEFB 1,38
             DEFB 1,17
             DEFB 151,34
             DEFB 151,17
             DEFB 151,34
             DEFB 151,17
             DEFB 151,34
             DEFB 151,17
             DEFB 151,34
             DEFB 1,17
             DEFB 61,34
             DEFB 51,17
             DEFB 61,34
             DEFB 51,17
             DEFB 1,34
             DEFB 1,17
             DEFB 1,34
             DEFB 1,17
             DEFB 61,34
             DEFB 51,17
             DEFB 61,34
             DEFB 51,17
             DEFB 1,34
             DEFB 1,17
             DEFB 1,34
             DEFB 1,15
             DEFB 151,30
             DEFB 151,15
             DEFB 151,30
             DEFB 151,15
             DEFB 151,30
             DEFB 151,15
             DEFB 151,30
             DEFB 1,15
             DEFB 61,30
             DEFB 51,15
             DEFB 61,30
             DEFB 51,15
             DEFB 1,30
             DEFB 1,15
             DEFB 1,30
             DEFB 1,15
             DEFB 61,30
             DEFB 51,15
             DEFB 61,30
             DEFB 51,15
             DEFB 1,30
             DEFB 1,15
             DEFB 1,30
             DEFB 1,15
         DEFB $0
PAT8:
         DEFB 250  ; Pattern tempo
             DEFB 192,51
             DEFB 192,25
             DEFB 192,51
             DEFB 192,25
             DEFB 192,51
             DEFB 192,25
             DEFB 192,51
             DEFB 1,25
             DEFB 76,51
             DEFB 64,25
             DEFB 76,51
             DEFB 64,25
             DEFB 1,51
             DEFB 1,25
             DEFB 1,51
             DEFB 1,25
             DEFB 76,51
             DEFB 64,25
             DEFB 76,51
             DEFB 64,25
             DEFB 1,51
             DEFB 1,25
             DEFB 1,51
             DEFB 1,24
             DEFB 192,48
             DEFB 192,24
             DEFB 192,48
             DEFB 192,24
             DEFB 192,48
             DEFB 192,24
             DEFB 192,48
             DEFB 1,24
             DEFB 76,48
             DEFB 64,24
             DEFB 76,48
             DEFB 64,24
             DEFB 1,48
             DEFB 1,24
             DEFB 1,48
             DEFB 1,24
             DEFB 76,48
             DEFB 64,24
             DEFB 76,48
             DEFB 64,24
             DEFB 1,48
             DEFB 1,24
             DEFB 1,48
             DEFB 1,21
             DEFB 192,43
             DEFB 192,21
             DEFB 192,43
             DEFB 192,21
             DEFB 192,43
             DEFB 192,21
             DEFB 192,43
             DEFB 1,21
             DEFB 76,43
             DEFB 64,21
             DEFB 76,43
             DEFB 64,21
             DEFB 1,43
             DEFB 1,21
             DEFB 1,43
             DEFB 1,21
             DEFB 76,43
             DEFB 64,21
             DEFB 76,43
             DEFB 64,21
             DEFB 1,43
             DEFB 1,21
             DEFB 1,43
             DEFB 1,19
             DEFB 192,38
             DEFB 192,19
             DEFB 192,38
             DEFB 192,19
             DEFB 192,38
             DEFB 192,19
             DEFB 192,38
             DEFB 1,19
             DEFB 76,38
             DEFB 64,19
             DEFB 76,38
             DEFB 64,19
             DEFB 1,38
             DEFB 1,19
             DEFB 1,38
             DEFB 1,19
             DEFB 76,38
             DEFB 64,19
             DEFB 76,38
             DEFB 64,19
             DEFB 1,38
             DEFB 1,19
             DEFB 1,38
             DEFB 1,19
         DEFB $0
